
#include <stdlib.h>

//#define DEBUG

#ifdef DEBUG
#include <stdio.h>
#endif

#define INPUT_STREAM "abdef"

/************* io module **********************/

static int
input_char(void) {
    static const char input_stream[] = INPUT_STREAM;
    static const char *ptr = input_stream;
    int c = *ptr;

    if (c != '\0')
      ptr++;
    else
      c = -1;

    return c;
}

/************* callbacks module ***************/

#define MAX_CB 26
static void (*callbacks[MAX_CB])(int);

static void
callback_register(int c, void (*cb)(int)) {
    callbacks[c - 'a'] = cb;
}

/* returns 1 if command not registered, 0 otherwise */
static int
callback_call(int c) {
    void (*cb)(int) = callbacks[c - 'a'];
    if (cb != NULL)
	cb(c);

    return cb == NULL;
}

/************* callbacks users ***************/

static void
xxx_cb(int c) {
#ifdef DEBUG
    printf("xxx %c\n", c);
#else
    (void) c;
#endif
}

static void
xxx_init(void) {
    callback_register('a', xxx_cb);
    callback_register('b', xxx_cb);
}

static void
yyy_cb(int c) {
#ifdef DEBUG
    printf("yyy %c\n", c);
#else
    (void) c;
#endif
}

static void
yyy_init(void) {
    callback_register('d', yyy_cb);
}

static void
zzz_cb(int c) {
#ifdef DEBUG
    printf("zzz %c\n", c);
#else
    (void) c;
#endif
}

static void
zzz_init(void) {
    callback_register('e', zzz_cb);
}

/************* main program **************/

int
_main(void) {
    xxx_init();
    yyy_init();
    zzz_init();

    for (;;) {
	int c = input_char();
	if (c == -1)
	    break;

	if (callback_call(c))
	    return EXIT_FAILURE;
    }

    return EXIT_SUCCESS;
}


void main (void)
{
  _main ();
  asm ( "hlt" );
}
